' shape to pointlist dh42 - 2014
' create a copy of the selected shape at each position of the point list

'select a point list and any drawing object - the point list must be the first selected object
'the center of the drawing is used as center for the objects to copy

sub main()

if view.SelectedEntities.Length > 1 then

	dim first as boolean = true
	dim pl as PointList

			for each ent as Entity in view.SelectedEntities
				
				'first entry must be a pointlist
				if first = true then
					if typeof ent is PointList then
						pl = ent
						first = false
					else
						msgbox("The first selected object must be a pointlist !")
						exit sub
					end if

				else 'other entries after the point list

					MoveShapeToPl(ent,pl)

				end if

			next ent

	end if

end sub

Sub MoveShapeToPl(ent as entity, p as PointList)

	'Copy and move a copy at each point in the point list

	dim e as entity = New Entity()
	

	'for each point in the pointlist

	for each pt as Point3F in p.points

		'copy the entity
		e = ent.clone()
		activelayer.Entities.Add(e)

		'move the copy to the current point location
		e.Transform.Translate(pt.x,pt.y,pt.z)

		' apply transformation
		if e.ApplyTransformation() then
		    e.Transform = Matrix4x4F.Identity
		end if

		view.RefreshView()

	next pt
	
End sub

